// soma.cpp: dfinit le point d'entre pour l'application console.

//
/*
Ce code est conu et dvelopper par Mohamed Hamzaoui
mohamed.hamzaoui@live.fr
Ce programme a t dvelopp en vue de resoudre le defi de soma.
Ce code est libre  utiliser et  distribuer
bonne lecture
*/
#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

#define NBRTOTALCUBE 27  //nombre de cube dans une forme donne
#define NBRDIMENSION 3  //nombre de dimensions heureusement qu'on n'est pas  la vitesse de lalumire
#define NBRPOS 1000  
struct COORDONNE {  //structure de coordonnee pour un cube (ou un point) dans notre repere
	short int x; //largeur
	short int y; //profondeur
	short int z; //hauteur
};
struct POSITIONV {  //structure de position pour une piece V (compte 3 cubes)
	struct COORDONNE alphaCube;
	struct COORDONNE betaCube;
	struct COORDONNE gammaCube;
};
struct POSITION {   //structure de position pour une pice des 6 restantes (celles qui comptent 4 cubes)
	struct COORDONNE alphaCube;
	struct COORDONNE betaCube;
	struct COORDONNE gammaCube;
	struct COORDONNE tetaCube;
};
typedef struct COORDONNE coord; 
typedef struct POSITION position;
typedef struct POSITIONV positionV;

coord forme[NBRTOTALCUBE];  //tableau qui va stocker la forme principale qui contient 27 cubes

positionV posV[NBRPOS]; //tableau pour stocker les positions possible d'une piece de forme V
position posL[NBRPOS];  //tableau pour stocker les positions possible d'une piece de forme L 
position posT[NBRPOS];	//tableau pour stocker les positions possible d'une piece de forme T
position posZ[NBRPOS];	//tableau pour stocker les positions possible d'une piece de forme Z
position posA[NBRPOS];	//tableau pour stocker les positions possible d'une piece de forme A
position posB[NBRPOS];	//tableau pour stocker les positions possible d'une piece de forme B
position posP[NBRPOS];	//tableau pour stocker les positions possible d'une piece de forme P

int nbrPosV=0; //le nombre de position possible de V
int nbrPosL=0; //le nombre de position possible de L
int nbrPosT=0; //le nombre de position possible de T
int nbrPosZ=0; //le nombre de position possible de Z
int nbrPosA=0; //le nombre de position possible de A
int nbrPosB=0; //le nombre de position possible de B
int nbrPosP=0; //le nombre de position possible de P
int used=0; //nombre de cubes utiliss (ou plutot reserves) parmi les 27
int positionVector[6]={0,0,0,0,0,0};


void afficherForme()//Fonction pour afficher les coordonnes d'une forme donne
{
	for (int i=0;i<NBRTOTALCUBE;++i)
	{
		printf("%d,%d,%d\n",forme[i].x,forme[i].y,forme[i].z);
	}
}

short int estEgal (coord a, coord b) //verifie l'galit des coordonnes de deux points (cubes)
{
	if (a.x==b.x && a.y==b.y && a.z==b.z)
		return 1;
	return 0;
}
short int existCoord(coord coordonne) //cherche un cube dans la liste des cubes restants cad qui ne sont pas dej reservs
{
	for (int i = 0;i<NBRTOTALCUBE-used;++i)
	{
		if (estEgal(coordonne,forme[i])==1)
			return i;
	}
	return -1;
}

void afficherCoord(coord coordonne) //affiche les coordonnee d'un point
{
	printf("coordonnee de position %d,%d,%d\n",coordonne.x,coordonne.y, coordonne.z);
}
/*Apres la recherche des postions possibles
  d'une forme V parmi les cubes restants cette
  fonction permet de nettoyer les doublons
  cad les positions qui ont ete insers plusieurs
  fois
*/
void nettoyerDoublonV() 
{
	int q=0;
	for (int i=0 ; i<nbrPosV; ++i)
		for (int j=i+1; j<nbrPosV; ++j)
			if ((estEgal(posV[i].alphaCube,posV[j].alphaCube)==1 
				|| estEgal(posV[i].alphaCube,posV[j].betaCube)==1
				|| estEgal(posV[i].alphaCube,posV[j].gammaCube)==1) &&
				(estEgal(posV[i].betaCube,posV[j].alphaCube)==1 
				|| estEgal(posV[i].betaCube,posV[j].betaCube)==1
				|| estEgal(posV[i].betaCube,posV[j].gammaCube)==1) &&
				(estEgal(posV[i].gammaCube,posV[j].alphaCube)==1 
				|| estEgal(posV[i].gammaCube,posV[j].betaCube)==1
				|| estEgal(posV[i].gammaCube,posV[j].gammaCube)==1))
			{
				
				for(int p=j;p<nbrPosV-1;++p)
				{
					posV[p]=posV[p+1];

				}
				nbrPosV--;
	
			}
				
}
/*
Apres la recherche des positions possibles,
d'une des pieces de 4 cubes, parmis les pieces
qui n'ont pas encore ete reservs. Cette fonction
permet de nettoyer les doublons.
C'est le meme principes que la precedantes mais
qui agit pour les pieces de 4
*/
void nettoyerDoublon(int *nbrPos, position *pos) 
{
	int q=0;
	for (int i=0 ; i<*nbrPos; ++i)
		for (int j=0; j<*nbrPos; ++j)
			if (i!=j)
				if ((estEgal((pos+i)->alphaCube,(pos+j)->alphaCube)==1 
				|| estEgal((pos+i)->alphaCube,(pos+j)->betaCube)==1
				|| estEgal((pos+i)->alphaCube,(pos+j)->gammaCube)==1
				|| estEgal((pos+i)->alphaCube,(pos+j)->tetaCube)==1) &&
				(estEgal((pos+i)->betaCube,(pos+j)->alphaCube)==1 
				|| estEgal((pos+i)->betaCube,(pos+j)->betaCube)==1
				|| estEgal((pos+i)->betaCube,(pos+j)->gammaCube)==1
				|| estEgal((pos+i)->betaCube,(pos+j)->tetaCube)==1) &&
				(estEgal((pos+i)->gammaCube,(pos+j)->alphaCube)==1 
				|| estEgal((pos+i)->gammaCube,(pos+j)->betaCube)==1
				|| estEgal((pos+i)->gammaCube,(pos+j)->gammaCube)==1
				|| estEgal((pos+i)->gammaCube,(pos+j)->tetaCube)==1) &&
				(estEgal((pos+i)->tetaCube,(pos+j)->alphaCube)==1 
				|| estEgal((pos+i)->tetaCube,(pos+j)->betaCube)==1
				|| estEgal((pos+i)->tetaCube,(pos+j)->gammaCube)==1
				|| estEgal((pos+i)->tetaCube,(pos+j)->tetaCube)==1))
			{
				//printf("doublon %d: %d,%d \n",++q,i,j);
				for(int p=j;p<*nbrPos-1;++p)
				{
					*(pos+p)=*(pos+p+1);

				}
				(*nbrPos)--;
	
			}
//printf("%d\n", *nbrPos);
}
/*
detecterPosV() est une fonction qui permet 
de prendre chaque cube et de detecter si 
parmi les cubes restants (qui ne sont pas reserves)
de la liste des cubes de la forme, ce cube forme 
avec les autres une piece V et ce on le faisant
pour chaque plan parmi les trois plan de notre espace.
cette operation comme vous allez le voir est bas sur un changement 
de repere et la limitation de la recherche comme on l'a evoqu
juste pour les pieces qui reste. ce qui augmente 
au max la vitesse de detection de la forme.
*/
void detecterPosV1(coord ref, coord aux1, coord aux2, int *nbrPos)
{
	if (existCoord(aux1)!=-1 && existCoord(aux2)!=-1)
		{
			posV[*nbrPos].alphaCube=ref;
			posV[*nbrPos].betaCube=aux1;
			posV[*nbrPos].gammaCube=aux2;
			++(*nbrPos);
		}
}
void detecterPosV()
{
	nbrPosV=0;
	
	coord aux1,aux2; //les deux autres cubes qui la compose
	/******verification pour le plan xy*****/
	for (int i=0;i<NBRTOTALCUBE-used;++i)
	{
		aux1.x=forme[i].x;
		aux1.y=forme[i].y-1;
		aux1.z=forme[i].z;
		aux2.x=forme[i].x-1;
		aux2.y=forme[i].y;
		aux2.z=forme[i].z;
		detecterPosV1(forme[i], aux1, aux2, &nbrPosV);

		aux1.x=forme[i].x;
		aux1.y=forme[i].y-1;
		aux1.z=forme[i].z;
		aux2.x=forme[i].x+1;
		aux2.y=forme[i].y;
		aux2.z=forme[i].z;
		detecterPosV1(forme[i], aux1, aux2, &nbrPosV);

		aux1.x=forme[i].x;
		aux1.y=forme[i].y+1;
		aux1.z=forme[i].z;
		aux2.x=forme[i].x-1;
		aux2.y=forme[i].y;
		aux2.z=forme[i].z;
		detecterPosV1(forme[i], aux1, aux2, &nbrPosV);

		aux1.x=forme[i].x;
		aux1.y=forme[i].y+1;
		aux1.z=forme[i].z;
		aux2.x=forme[i].x+1;
		aux2.y=forme[i].y;
		aux2.z=forme[i].z;
		detecterPosV1(forme[i], aux1, aux2, &nbrPosV);

		/******verification pour le plan xz*****/
		
		aux1.x=forme[i].x-1;
		aux1.y=forme[i].y;
		aux1.z=forme[i].z;
		aux2.x=forme[i].x;
		aux2.y=forme[i].y;
		aux2.z=forme[i].z-1;
		detecterPosV1(forme[i], aux1, aux2, &nbrPosV);

		aux1.x=forme[i].x-1;
		aux1.y=forme[i].y;
		aux1.z=forme[i].z;
		aux2.x=forme[i].x;
		aux2.y=forme[i].y;
		aux2.z=forme[i].z+1;
		detecterPosV1(forme[i], aux1, aux2, &nbrPosV);

		aux1.x=forme[i].x+1;
		aux1.y=forme[i].y;
		aux1.z=forme[i].z;
		aux2.x=forme[i].x;
		aux2.y=forme[i].y;
		aux2.z=forme[i].z-1;
		detecterPosV1(forme[i], aux1, aux2, &nbrPosV);

		aux1.x=forme[i].x+1;
		aux1.y=forme[i].y;
		aux1.z=forme[i].z;
		aux2.x=forme[i].x;
		aux2.y=forme[i].y;
		aux2.z=forme[i].z+1;
		detecterPosV1(forme[i], aux1, aux2, &nbrPosV);


		/******verification pour le plan yz*****/
		
		aux1.x=forme[i].x;
		aux1.y=forme[i].y-1;
		aux1.z=forme[i].z;
		aux2.x=forme[i].x;
		aux2.y=forme[i].y;
		aux2.z=forme[i].z-1;
		detecterPosV1(forme[i], aux1, aux2, &nbrPosV);

		aux1.x=forme[i].x;
		aux1.y=forme[i].y-1;
		aux1.z=forme[i].z;
		aux2.x=forme[i].x;
		aux2.y=forme[i].y;
		aux2.z=forme[i].z+1;
		detecterPosV1(forme[i], aux1, aux2, &nbrPosV);

		aux1.x=forme[i].x;
		aux1.y=forme[i].y+1;
		aux1.z=forme[i].z;
		aux2.x=forme[i].x;
		aux2.y=forme[i].y;
		aux2.z=forme[i].z-1;
		detecterPosV1(forme[i], aux1, aux2, &nbrPosV);

		aux1.x=forme[i].x;
		aux1.y=forme[i].y+1;
		aux1.z=forme[i].z;
		aux2.x=forme[i].x;
		aux2.y=forme[i].y;
		aux2.z=forme[i].z+1;
		detecterPosV1(forme[i], aux1, aux2, &nbrPosV);
	}
	//printf("%d\n",nbrPosV);
	nettoyerDoublonV();
}

void detecterPos(coord ref,int *nbrPos, char type,
				 short int a1, short int b1, short int c1, 
				 short int a2, short int b2, short int c2, 
				 short int a3, short int b3, short int c3)
{
	coord aux1,aux2,aux3;
	aux1.x=ref.x+a1;
	aux1.y=ref.y+b1;
	aux1.z=ref.z+c1;
	aux2.x=ref.x+a2;
	aux2.y=ref.y+b2;
	aux2.z=ref.z+c2;
	aux3.x=ref.x+a3;
	aux3.y=ref.y+b3;
	aux3.z=ref.z+c3;
	if (existCoord(aux1)!=-1 && existCoord(aux2)!=-1 && existCoord(aux3)!=-1)
	{
		
		//afficherCoord(ref);
		//afficherCoord(aux1);
		//afficherCoord(aux2);
		//afficherCoord(aux3);
		switch (type)
		{
		case 'L':
			posL[*nbrPos].alphaCube=ref;
			posL[*nbrPos].betaCube=aux1;
			posL[*nbrPos].gammaCube=aux2;
			posL[*nbrPos].tetaCube=aux3;
			break;
		case 'T':
			posT[*nbrPos].alphaCube=ref;
			posT[*nbrPos].betaCube=aux1;
			posT[*nbrPos].gammaCube=aux2;
			posT[*nbrPos].tetaCube=aux3;
			break;
		case 'Z':
			posZ[*nbrPos].alphaCube=ref;
			posZ[*nbrPos].betaCube=aux1;
			posZ[*nbrPos].gammaCube=aux2;
			posZ[*nbrPos].tetaCube=aux3;
			break;
		case 'A':
			posA[*nbrPos].alphaCube=ref;
			posA[*nbrPos].betaCube=aux1;
			posA[*nbrPos].gammaCube=aux2;
			posA[*nbrPos].tetaCube=aux3;
			break;
		case 'B':
			posB[*nbrPos].alphaCube=ref;
			posB[*nbrPos].betaCube=aux1;
			posB[*nbrPos].gammaCube=aux2;
			posB[*nbrPos].tetaCube=aux3;
			break;
		case 'P':
			posP[*nbrPos].alphaCube=ref;
			posP[*nbrPos].betaCube=aux1;
			posP[*nbrPos].gammaCube=aux2;
			posP[*nbrPos].tetaCube=aux3;
			break;
		}
		++(*nbrPos);
	}
}
/*
detecterPosX() o X est la piece cherch 
est une fonction qui permet 
de prendre chaque cube et de detecter si 
parmi les cubes restants (qui ne sont pas reserves)
de la liste des cubes de la forme, ce cube forme 
avec les autres une piece V et ce on le faisant
pour chaque plan parmi les trois plan de notre espace.
cette operation comme vous allez le voir est bas sur un changement 
de repere et la limitation de la recherche comme on l'a evoqu
juste pour les pieces qui reste. ce qui augmente 
au max la vitesse de detection de la forme.
*/
void detecterPosL()
{
	nbrPosL=0;
	/******verification pour le plan xy*****/
	for (int i=0;i<NBRTOTALCUBE-used;++i)
	{
		detecterPos(forme[i],&nbrPosL,'L',0,-1,0,  -1,0,0,  -2,0,0);
		detecterPos(forme[i],&nbrPosL,'L',0,-1,0,  -1,0,0,  0,-2,0);

		detecterPos(forme[i],&nbrPosL,'L',0,-1,0,  1,0,0,  2,0,0);
		detecterPos(forme[i],&nbrPosL,'L',0,-1,0,  1,0,0,  0,-2,0);

		detecterPos(forme[i],&nbrPosL,'L',0,1,0,  -1,0,0,  -2,0,0);
		detecterPos(forme[i],&nbrPosL,'L',0,1,0,  -1,0,0,  0,2,0);

		detecterPos(forme[i],&nbrPosL,'L',0,1,0,  1,0,0,  2,0,0);
		detecterPos(forme[i],&nbrPosL,'L',0,1,0,  1,0,0,  0,2,0);


		/******verification pour le plan xz*****/
		detecterPos(forme[i],&nbrPosL,'L',0,0,-1,  -1,0,0,  -2,0,0);
		detecterPos(forme[i],&nbrPosL,'L',0,0,-1,  -1,0,0,  0,0,-2);

		detecterPos(forme[i],&nbrPosL,'L',0,0,-1,  1,0,0,  2,0,0);
		detecterPos(forme[i],&nbrPosL,'L',0,0,-1,  1,0,0,  0,0,-2);

		detecterPos(forme[i],&nbrPosL,'L',0,0,1,  -1,0,0,  -2,0,0);
		detecterPos(forme[i],&nbrPosL,'L',0,0,1,  -1,0,0,  0,0,2);

		detecterPos(forme[i],&nbrPosL,'L',0,0,1,  1,0,0,  2,0,0);
		detecterPos(forme[i],&nbrPosL,'L',0,0,1,  1,0,0,  0,0,2);

		
		/******verification pour le plan yz*****/
		detecterPos(forme[i],&nbrPosL,'L',0,0,-1,  0,-1,0,  0,-2,0);
		detecterPos(forme[i],&nbrPosL,'L',0,0,-1,  0,-1,0,  0,0,-2);

		detecterPos(forme[i],&nbrPosL,'L',0,0,-1,  0,1,0,  0,2,0);
		detecterPos(forme[i],&nbrPosL,'L',0,0,-1,  0,1,0,  0,0,-2);

		detecterPos(forme[i],&nbrPosL,'L',0,0,1,  0,-1,0,  0,-2,0);
		detecterPos(forme[i],&nbrPosL,'L',0,0,1,  0,-1,0,  0,0,2);

		detecterPos(forme[i],&nbrPosL,'L',0,0,1,  0,1,0,  0,2,0);
		detecterPos(forme[i],&nbrPosL,'L',0,0,1,  0,1,0,  0,0,2);
		
	}
	nettoyerDoublon(&nbrPosL,posL);
}
void detecterPosT()
{
	nbrPosT=0;
	/******verification pour le plan xy*****/
	for (int i=0;i<NBRTOTALCUBE-used;++i)
	{
		detecterPos(forme[i],&nbrPosT,'T',0,-1,0,  -1,0,0,  1,0,0);
		detecterPos(forme[i],&nbrPosT,'T',-1,0,0,  0,-1,0,  0,1,0);
		detecterPos(forme[i],&nbrPosT,'T',0,1,0,   -1,0,0,  1,0,0);
		detecterPos(forme[i],&nbrPosT,'T',1,0,0,  0,-1,0,  0,1,0);
		


		/******verification pour le plan xz*****/
		
		detecterPos(forme[i],&nbrPosT,'T',0,0,-1,  -1,0,0,  1,0,0);
		detecterPos(forme[i],&nbrPosT,'T',-1,0,0,  0,0,-1,  0,0,1);
		detecterPos(forme[i],&nbrPosT,'T',0,0,1,   -1,0,0,  1,0,0);
		detecterPos(forme[i],&nbrPosT,'T',1,0,0,   0,0,-1,  0,0,1);

		/******verification pour le plan yz*****/
		
		detecterPos(forme[i],&nbrPosT,'T',0,-1,0,  0,0,-1,  0,0,1);
		detecterPos(forme[i],&nbrPosT,'T',0,0,-1,  0,-1,0,  0,1,0);
		detecterPos(forme[i],&nbrPosT,'T',0,1,0,   0,0,-1,  0,0,1);
		detecterPos(forme[i],&nbrPosT,'T',0,0,1,  0,-1,0,  0,1,0);
	}
	//printf("%d\n",nbrPosT);
	nettoyerDoublon(&nbrPosT,posT);
}
void detecterPosZ()
{
	nbrPosZ=0;
	/******verification pour le plan xy*****/
	for (int i=0;i<NBRTOTALCUBE-used;++i)
	{
		detecterPos(forme[i],&nbrPosZ,'Z',0,-1,0,  -1,-1,0,  1,0,0);
		detecterPos(forme[i],&nbrPosZ,'Z',-1,0,0,  0,-1,0,  -1,1,0);
		detecterPos(forme[i],&nbrPosZ,'Z',0,1,0,   -1,0,0,  1,1,0);
		detecterPos(forme[i],&nbrPosZ,'Z',1,0,0,  1,-1,0,  0,1,0);
		
		detecterPos(forme[i],&nbrPosZ,'Z',0,-1,0,  1,-1,0,  -1,0,0);
		detecterPos(forme[i],&nbrPosZ,'Z',-1,0,0,  0,1,0,  -1,-1,0);
		detecterPos(forme[i],&nbrPosZ,'Z',0,1,0,   1,0,0,  -1,1,0);
		detecterPos(forme[i],&nbrPosZ,'Z',1,0,0,  1,1,0,  0,-1,0);
		


		/******verification pour le plan xz*****/
		
		detecterPos(forme[i],&nbrPosZ,'Z',0,0,-1,  -1,0,-1,  1,0,0);
		detecterPos(forme[i],&nbrPosZ,'Z',-1,0,0,  0,0,-1,  -1,0,1);
		detecterPos(forme[i],&nbrPosZ,'Z',0,0,1,   -1,0,0,  1,0,1);
		detecterPos(forme[i],&nbrPosZ,'Z',1,0,0,  1,0,-1,  0,0,1);
		
		detecterPos(forme[i],&nbrPosZ,'Z',0,0,-1,  1,0,-1,  -1,0,0);
		detecterPos(forme[i],&nbrPosZ,'Z',-1,0,0,  0,0,1,  -1,0,-1);
		detecterPos(forme[i],&nbrPosZ,'Z',0,0,1,   1,0,0,  -1,0,1);
		detecterPos(forme[i],&nbrPosZ,'Z',1,0,0,  1,0,1,  0,0,-1);
		
		/******verification pour le plan yz*****/
		
		detecterPos(forme[i],&nbrPosZ,'Z',0,-1,0,  0,-1,-1,  0,0,1);
		detecterPos(forme[i],&nbrPosZ,'Z',0,0,-1,  0,-1,0,  0,1,-1);
		detecterPos(forme[i],&nbrPosZ,'Z',0,1,0,   0,0,-1,  0,1,1);
		detecterPos(forme[i],&nbrPosZ,'Z',0,0,1,  0,-1,1,  0,1,0);
		
		detecterPos(forme[i],&nbrPosZ,'Z',0,-1,0,  0,-1,1,  0,0,-1);
		detecterPos(forme[i],&nbrPosZ,'Z',0,0,-1,  0,1,0,  0,-1,-1);
		detecterPos(forme[i],&nbrPosZ,'Z',0,1,0,   0,0,1,  0,1,-1);
		detecterPos(forme[i],&nbrPosZ,'Z',0,0,1,  0,1,1,  0,-1,0);
	}
	//printf("%d\n",nbrPosZ);
	nettoyerDoublon(&nbrPosZ,posZ);

}
void detecterPosA()
{
	nbrPosA=0;
	/******verification pour le plan xy*****/
	for (int i=0;i<NBRTOTALCUBE-used;++i)
	{
		detecterPos(forme[i],&nbrPosA, 'A',0,-1,0,  -1,0,0,  0,-1,1);
		detecterPos(forme[i],&nbrPosA, 'A',0,-1,0,  -1,0,0,  -1,0,-1);

		detecterPos(forme[i],&nbrPosA, 'A',0,-1,0,  1,0,0,  0,-1,1);
		detecterPos(forme[i],&nbrPosA, 'A',0,-1,0,  1,0,0,  1,0,-1);

		detecterPos(forme[i],&nbrPosA, 'A',0,1,0,  -1,0,0,  0,1,1);
		detecterPos(forme[i],&nbrPosA, 'A',0,1,0,  -1,0,0,  -1,0,-1);

		detecterPos(forme[i],&nbrPosA, 'A',0,1,0,  1,0,0,  0,1,1);
		detecterPos(forme[i],&nbrPosA, 'A',0,1,0,  1,0,0,  1,0,-1);


		/******verification pour le plan xz*****/
		detecterPos(forme[i],&nbrPosA, 'A',0,0,-1,  -1,0,0,  0,1,-1);
		detecterPos(forme[i],&nbrPosA, 'A',0,0,-1,  -1,0,0,  -1,-1,0);

		detecterPos(forme[i],&nbrPosA, 'A',0,0,-1,  1,0,0,  0,1,-1);
		detecterPos(forme[i],&nbrPosA, 'A',0,0,-1,  1,0,0,  1,-1,0);

		detecterPos(forme[i],&nbrPosA, 'A',0,0,1,  -1,0,0,  0,1,1);
		detecterPos(forme[i],&nbrPosA, 'A',0,0,1,  -1,0,0,  -1,-1,0);

		detecterPos(forme[i],&nbrPosA, 'A',0,0,1,  1,0,0,  0,1,1);
		detecterPos(forme[i],&nbrPosA, 'A',0,0,1,  1,0,0,  1,-1,0);

		
		/******verification pour le plan yz*****/
		detecterPos(forme[i],&nbrPosA, 'A',0,-1,0,  0,0,-1,  1,-1,0);
		detecterPos(forme[i],&nbrPosA, 'A',0,-1,0,  0,0,-1,  -1,0,-1);

		detecterPos(forme[i],&nbrPosA, 'A',0,-1,0,  0,0,1,  1,-1,0);
		detecterPos(forme[i],&nbrPosA, 'A',0,-1,0,  0,0,1,  -1,0,1);

		detecterPos(forme[i],&nbrPosA, 'A',0,1,0,  0,0,-1,  1,1,0);
		detecterPos(forme[i],&nbrPosA, 'A',0,1,0,  0,0,-1,  -1,0,-1);

		detecterPos(forme[i],&nbrPosA, 'A',0,1,0,  0,0,1,  1,1,0);
		detecterPos(forme[i],&nbrPosA, 'A',0,1,0,  0,0,1,  -1,0,1);
		
	}
	//printf("%d\n",nbrPosA);
	nettoyerDoublon(&nbrPosA,posA);
}
void detecterPosB()
{
	nbrPosB=0;
	/******verification pour le plan xy*****/
	for (int i=0;i<NBRTOTALCUBE-used;++i)
	{
		detecterPos(forme[i],&nbrPosB, 'B',0,-1,0,  -1,0,0,  0,-1,-1);
		detecterPos(forme[i],&nbrPosB, 'B',0,-1,0,  -1,0,0,  -1,0,1);

		detecterPos(forme[i],&nbrPosB, 'B',0,-1,0,  1,0,0,  0,-1,-1);
		detecterPos(forme[i],&nbrPosB, 'B',0,-1,0,  1,0,0,  1,0,1);

		detecterPos(forme[i],&nbrPosB, 'B',0,1,0,  -1,0,0,  0,1,-1);
		detecterPos(forme[i],&nbrPosB, 'B',0,1,0,  -1,0,0,  -1,0,1);

		detecterPos(forme[i],&nbrPosB, 'B',0,1,0,  1,0,0,  0,1,-1);
		detecterPos(forme[i],&nbrPosB, 'B',0,1,0,  1,0,0,  1,0,1);


		/******verification pour le plan xz*****/
		detecterPos(forme[i],&nbrPosB, 'B',0,0,-1,  -1,0,0,  0,-1,-1);
		detecterPos(forme[i],&nbrPosB, 'B',0,0,-1,  -1,0,0,  -1,1,0);

		detecterPos(forme[i],&nbrPosB, 'B',0,0,-1,  1,0,0,  0,-1,-1);
		detecterPos(forme[i],&nbrPosB, 'B',0,0,-1,  1,0,0,  1,1,0);

		detecterPos(forme[i],&nbrPosB, 'B',0,0,1,  -1,0,0,  0,-1,1);
		detecterPos(forme[i],&nbrPosB, 'B',0,0,1,  -1,0,0,  -1,1,0);

		detecterPos(forme[i],&nbrPosB, 'B',0,0,1,  1,0,0,  0,-1,1);
		detecterPos(forme[i],&nbrPosB, 'B',0,0,1,  1,0,0,  1,1,0);

		
		/******verification pour le plan yz*****/
		detecterPos(forme[i],&nbrPosB, 'B',0,-1,0,  0,0,-1,  -1,-1,0);
		detecterPos(forme[i],&nbrPosB, 'B',0,-1,0,  0,0,-1,  1,0,-1);

		detecterPos(forme[i],&nbrPosB, 'B',0,-1,0,  0,0,1,  -1,-1,0);
		detecterPos(forme[i],&nbrPosB, 'B',0,-1,0,  0,0,1,  1,0,1);

		detecterPos(forme[i],&nbrPosB, 'B',0,1,0,  0,0,-1,  -1,1,0);
		detecterPos(forme[i],&nbrPosB, 'B',0,1,0,  0,0,-1,  1,0,-1);

		detecterPos(forme[i],&nbrPosB, 'B',0,1,0,  0,0,1,  -1,1,0);
		detecterPos(forme[i],&nbrPosB, 'B',0,1,0,  0,0,1,  1,0,1);
		
	}
	//printf("%d\n",nbrPosB);
	nettoyerDoublon(&nbrPosB,posB);
}
void detecterPosP()
{
	nbrPosP=0;
	/******verification pour le plan xy*****/
	for (int i=0;i<NBRTOTALCUBE-used;++i)
	{
		detecterPos(forme[i],&nbrPosP,'P',0,-1,0,  -1,0,0,  0,0,-1);
		detecterPos(forme[i],&nbrPosP,'P',0,-1,0,  -1,0,0,  0,0,1);

		detecterPos(forme[i],&nbrPosP,'P',0,-1,0,  1,0,0,  0,0,-1);
		detecterPos(forme[i],&nbrPosP,'P',0,-1,0,  1,0,0,  0,0,1);

		detecterPos(forme[i],&nbrPosP,'P',0,1,0,  -1,0,0,  0,0,-1);
		detecterPos(forme[i],&nbrPosP,'P',0,1,0,  -1,0,0,  0,0,1);

		detecterPos(forme[i],&nbrPosP,'P',0,1,0,  1,0,0,  0,0,-1);
		detecterPos(forme[i],&nbrPosP,'P',0,1,0,  1,0,0,  0,0,1);


		/******verification pour le plan xz*****/
		detecterPos(forme[i],&nbrPosP,'P',0,0,-1,  -1,0,0,  0,-1,0);
		detecterPos(forme[i],&nbrPosP,'P',0,0,-1,  -1,0,0,  0,1,0);

		detecterPos(forme[i],&nbrPosP,'P',0,0,-1,  1,0,0,  0,-1,0);
		detecterPos(forme[i],&nbrPosP,'P',0,0,-1,  1,0,0,  0,1,0);

		detecterPos(forme[i],&nbrPosP,'P',0,0,1,  -1,0,0,  0,-1,0);
		detecterPos(forme[i],&nbrPosP,'P',0,0,1,  -1,0,0,  0,1,0);

		detecterPos(forme[i],&nbrPosP,'P',0,0,1,  1,0,0,  0,-1,0);
		detecterPos(forme[i],&nbrPosP,'P',0,0,1,  1,0,0,  0,1,0);

		
		/******verification pour le plan yz*****/
		detecterPos(forme[i],&nbrPosP,'P',0,0,-1,  0,-1,0,  -1,0,0);
		detecterPos(forme[i],&nbrPosP,'P',0,0,-1,  0,-1,0,  1,0,0);

		detecterPos(forme[i],&nbrPosP,'P',0,0,-1,  0,1,0,  -1,0,0);
		detecterPos(forme[i],&nbrPosP,'P',0,0,-1,  0,1,0,  1,0,0);

		detecterPos(forme[i],&nbrPosP,'P',0,0,1,  0,-1,0,  -1,0,0);
		detecterPos(forme[i],&nbrPosP,'P',0,0,1,  0,-1,0,  1,0,0);

		detecterPos(forme[i],&nbrPosP,'P',0,0,1,  0,1,0,  -1,0,0);
		detecterPos(forme[i],&nbrPosP,'P',0,0,1,  0,1,0,  1,0,0);
		
	}
	//printf("%d\n",nbrPosP);
	nettoyerDoublon(&nbrPosP,posP);
}
void chargerForme(char *nomFichier) //Foncton de chargement de la forme depuis le fichier texte dej defini
{
	FILE* srcForme = NULL;
	if ((srcForme=fopen(nomFichier,"r"))==NULL)
	{
		perror("Lecture impossible");
		exit(-1);
	}
	int i=0,ret;
	do
	{
		ret=fscanf(srcForme,"%1d,%1d,%1d\n",&forme[i].x,&forme[i].y,&forme[i].z);
		used=(used<0)?27:(NBRTOTALCUBE-i);
		++i;
	}
	while (feof(srcForme)==0&&ret==3&&
		forme[i-1].x >= 0 && forme[i-1].x <= 9 &&
		forme[i-1].y >= 0 && forme[i-1].y <= 9 &&
		forme[i-1].z >= 0 && forme[i-1].z <= 9 &&
		existCoord(forme[i-1])==-1);
	fclose(srcForme);
	used=0;
	if (i!=27) {printf("%d Fichier Invalide",ret);
	exit(-1);}
}


int minPos(int *nbrpos, int n) 
{
	int *min = nbrpos;
	for (int i=0;i<n;++i)
		if (*(nbrpos+i)<*min)
			min=(nbrpos+i);
	return (min-nbrpos);
}
void eliminerCube(coord cube,int usedd) //elimine un cube de la liste (decrite dans forme)
{
	coord aux; 
	aux.x=99;aux.y=99;aux.z=99;//case vide
	int i=existCoord(cube);
	for (int p=i;p<NBRTOTALCUBE-1;++p)
	{
		forme[p]=forme[p+1];
	}
	forme[NBRTOTALCUBE-1]=aux;
	used=usedd;
}
void chargerPositionVector()
{
	if (positionVector[0]!=9999) detecterPosL();
	positionVector[0]=(positionVector[0]==9999)?9999:nbrPosL;
	if (positionVector[1]!=9999) detecterPosT();
	positionVector[1]=(positionVector[1]==9999)?9999:nbrPosT;
	if (positionVector[2]!=9999) detecterPosZ();
	positionVector[2]=(positionVector[2]==9999)?9999:nbrPosZ;
	if (positionVector[3]!=9999) detecterPosA();
	positionVector[3]=(positionVector[3]==9999)?9999:nbrPosA;
	if (positionVector[4]!=9999) detecterPosB();
	positionVector[4]=(positionVector[4]==9999)?9999:nbrPosB;
	if (positionVector[5]!=9999) detecterPosP();
	positionVector[5]=(positionVector[5]==9999)?9999:nbrPosP;
}
int chercherSolutionPart(int *nbrPos, position **pos)
{
	chargerPositionVector();
	int minpos=minPos(positionVector,6);
	switch (minpos+1)
	{
	case 1 :
		*nbrPos=nbrPosL;
		*pos=posL;
		
		break;
	case 2 :
		
		*nbrPos=nbrPosT;
		*pos=posT;
		
		break;
	case 3 :
		
		*nbrPos=nbrPosZ;
		*pos=posZ;
		
		break;
	case 4 :
		
		*nbrPos=nbrPosA;
		*pos=posA;
		
		break;
	case 5 :
		
		*nbrPos=nbrPosB;
		*pos=posB;
		
		break;
	case 6 :
		
		*nbrPos=nbrPosP;
		*pos=posP;
		
		break;
	}
	return minpos;
}
void ecrireNature(int aux) //juste pour un affichage claire de la solution
{
	switch (aux+1)
	{
	case 1 :
		puts("L : ");
		break;
	case 2 :
		puts("T : ");
		break;
	case 3 :
		puts("Z : ");
		break;
	case 4 :
		puts("A : ");
		break;
	case 5 :
		puts("B : ");
		break;
	case 6 :
		puts("P : ");
		break;
	}
}
/*
La fonction chercherSolution() est la fonction principale de recherche : 
l'ide est : on commence par la detection des place possibles de chaque 
piece de 4 cubes cad L T Z A B P (on n'inclu pas la piece V car elle a 
statiquement tjrs le grand nombre de positions possible) puis on choisi 
celle qui a le moins de place possible (j'espere que ce point est claire) 
ensuite on commence par la premiere position de cette piece on reserve 
les cube de cette premiere position et donc on aura 23 cubes libres.
Ensuite on recherche parmi ces 23 cubes les positions possibles des pieces
restantes et on choisit la piece qui a moins de possibilit et on lui reserve
la premiere position et on continue jusqu'a ce que on trouve plus de place 
possibles pour les autres pieces donc on passe  la deuxieme position de la liste 
de la derniere piece puis on cas d'epuisement de la precedante... jusqu'a la premiere
et ainsi de suite jusqu'a trouver une forme possible ou non.
avec le choix de developper les pieces qui ont le moins possible de places
on minimise au max le nombre des branches  parcourir dans notre recherche
et donc on aboutit au resultat pls vite.
NB : on peut modifier la resolution de telle faon que la fonction nous donne tous
les resultats possibles et ce on laissant la fonction terminer l'execution jusqu'a
la fin et non pas arreter lors de la premiere solution trouve
*/
int chercherSolution()
{
	position *pos1=NULL, *pos2=NULL, *pos3=NULL, *pos4=NULL, *pos5=NULL, *pos6=NULL, *pos7=NULL;
	int nbrPos1, nbrPos2, nbrPos3, nbrPos4, nbrPos5, nbrPos6, nbrPos7;
	int aux1, aux2, aux3, aux4, aux5, aux6; 

	aux1=chercherSolutionPart(&nbrPos1,&pos1);
	positionVector[aux1]=9999;
	for (int a1=0;a1 < nbrPos1;++a1)
	{
		eliminerCube((pos1+a1)->alphaCube,1);
		eliminerCube(((pos1+a1))->betaCube,2);
		eliminerCube(((pos1+a1))->gammaCube,3);
		eliminerCube(((pos1+a1))->tetaCube,4);
		
		/*************/
		
		aux2=chercherSolutionPart(&nbrPos2,&pos2);
		positionVector[aux2]=9999;
	
		for (int a2=0;a2<nbrPos2;++a2)
		{
			eliminerCube(((pos2+a2))->alphaCube,5);
			eliminerCube(((pos2+a2))->betaCube,6);
			eliminerCube(((pos2+a2))->gammaCube,7);
			eliminerCube(((pos2+a2))->tetaCube,8);
			
			/********************/
			
			aux3=chercherSolutionPart(&nbrPos3,&pos3);
			positionVector[aux3]=9999;
			
			for (int a3=0;a3<nbrPos3;++a3)
			{
				eliminerCube(((pos3+a3))->alphaCube,9);
				eliminerCube(((pos3+a3))->betaCube,10);
				eliminerCube(((pos3+a3))->gammaCube,11);
				eliminerCube(((pos3+a3))->tetaCube,12);
				
				/**************/
				
				aux4=chercherSolutionPart(&nbrPos4,&pos4);
				positionVector[aux4]=9999;
			
				for (int a4=0;a4<nbrPos4;++a4)
				{
					eliminerCube(((pos4+a4))->alphaCube,13);
					eliminerCube(((pos4+a4))->betaCube,14);
					eliminerCube(((pos4+a4))->gammaCube,15);
					eliminerCube(((pos4+a4))->tetaCube,16);
					
					/**************/
					aux5=chercherSolutionPart(&nbrPos5,&pos5);
					positionVector[aux5]=9999;
				
					for (int a5=0;a5<nbrPos5;++a5)
					{
						eliminerCube(((pos5+a5))->alphaCube,17);
						eliminerCube(((pos5+a5))->betaCube,18);
						eliminerCube(((pos5+a5))->gammaCube,19);
						eliminerCube(((pos5+a5))->tetaCube,20);
						
						/**************/
						aux6=chercherSolutionPart(&nbrPos6,&pos6);
						positionVector[aux6]=9999;
					
						for (int a6=0;a6<nbrPos6;++a6)
						{
							eliminerCube(((pos6+a6))->alphaCube,21);
							eliminerCube(((pos6+a6))->betaCube,22);
							eliminerCube(((pos6+a6))->gammaCube,23);
							eliminerCube(((pos6+a6))->tetaCube,24);
						
							/**************/
							detecterPosV();
						
							for (int a7=0;a7<nbrPosV;++a7)
							{
								eliminerCube(posV[a7].alphaCube,25);
								eliminerCube(posV[a7].betaCube,26);
								eliminerCube(posV[a7].gammaCube,27);
								/*****AFFICHAGE DU PREMIER RESULTAT ET SORTIE*********/
								puts("Succes");
								puts("voici le resultat complet :\nV : ");
								afficherCoord(posV[a7].alphaCube);
								afficherCoord(posV[a7].betaCube);
								afficherCoord(posV[a7].gammaCube);
								ecrireNature(aux6);
								afficherCoord(((pos6+a6))->alphaCube);
								afficherCoord(((pos6+a6))->betaCube);
								afficherCoord(((pos6+a6))->gammaCube);
								afficherCoord(((pos6+a6))->tetaCube);
								ecrireNature(aux5);
								afficherCoord(((pos5+a5))->alphaCube);
								afficherCoord(((pos5+a5))->betaCube);
								afficherCoord(((pos5+a5))->gammaCube);
								afficherCoord(((pos5+a5))->tetaCube);
								ecrireNature(aux4);
								afficherCoord(((pos4+a4))->alphaCube);
								afficherCoord(((pos4+a4))->betaCube);
								afficherCoord(((pos4+a4))->gammaCube);
								afficherCoord(((pos4+a4))->tetaCube);
								ecrireNature(aux3);
								afficherCoord(((pos3+a3))->alphaCube);
								afficherCoord(((pos3+a3))->betaCube);
								afficherCoord(((pos3+a3))->gammaCube);
								afficherCoord(((pos3+a3))->tetaCube);
								ecrireNature(aux2);
								afficherCoord(((pos2+a2))->alphaCube);
								afficherCoord(((pos2+a2))->betaCube);
								afficherCoord(((pos2+a2))->gammaCube);
								afficherCoord(((pos2+a2))->tetaCube);
								ecrireNature(aux1);
								afficherCoord(((pos1+a1))->alphaCube);
								afficherCoord(((pos1+a1))->betaCube);
								afficherCoord(((pos1+a1))->gammaCube);
								afficherCoord(((pos1+a1))->tetaCube);
								return 0;
							}
							
							
							forme[NBRTOTALCUBE-1-used+1]=(*(pos6+a6)).alphaCube;
							forme[NBRTOTALCUBE-1-used+2]=(*(pos6+a6)).betaCube;
							forme[NBRTOTALCUBE-1-used+3]=(*(pos6+a6)).gammaCube;
							forme[NBRTOTALCUBE-1-used+4]=(*(pos6+a6)).tetaCube;
							used=20;
						}positionVector[aux6]=0;
						used=20;
						forme[NBRTOTALCUBE-1-used+1]=(*(pos5+a5)).alphaCube;
						forme[NBRTOTALCUBE-1-used+2]=(*(pos5+a5)).betaCube;
						forme[NBRTOTALCUBE-1-used+3]=(*(pos5+a5)).gammaCube;
						forme[NBRTOTALCUBE-1-used+4]=(*(pos5+a5)).tetaCube;
						used=16;
						
					}positionVector[aux5]=0;
					used=16;
					forme[NBRTOTALCUBE-1-used+1]=(*(pos4+a4)).alphaCube;
					forme[NBRTOTALCUBE-1-used+2]=(*(pos4+a4)).betaCube;
					forme[NBRTOTALCUBE-1-used+3]=(*(pos4+a4)).gammaCube;
					forme[NBRTOTALCUBE-1-used+4]=(*(pos4+a4)).tetaCube;
					used=12;
					
				}positionVector[aux4]=0;
				used=12;
				forme[NBRTOTALCUBE-1-used+1]=(*(pos3+a3)).alphaCube;
				forme[NBRTOTALCUBE-1-used+2]=(*(pos3+a3)).betaCube;
				forme[NBRTOTALCUBE-1-used+3]=(*(pos3+a3)).gammaCube;
				forme[NBRTOTALCUBE-1-used+4]=(*(pos3+a3)).tetaCube;
				used=8;
				
			}positionVector[aux3]=0;
			used=8;
			forme[NBRTOTALCUBE-1-used+1]=(*(pos2+a2)).alphaCube;
			forme[NBRTOTALCUBE-1-used+2]=(*(pos2+a2)).betaCube;
			forme[NBRTOTALCUBE-1-used+3]=(*(pos2+a2)).gammaCube;
			forme[NBRTOTALCUBE-1-used+4]=(*(pos2+a2)).tetaCube;
			used=4;
			
		}positionVector[aux2]=0;
		used=4;
		forme[NBRTOTALCUBE-1-used+1]=(*(pos1+a1)).alphaCube;
		forme[NBRTOTALCUBE-1-used+2]=(*(pos1+a1)).betaCube;
		forme[NBRTOTALCUBE-1-used+3]=(*(pos1+a1)).gammaCube;
		forme[NBRTOTALCUBE-1-used+4]=(*(pos1+a1)).tetaCube;
		used=0;
	}
	printf("Impossible\n");
	return 1;
}
int main(int argc,char **argv)
{
	long depart=0, fin=0, duree=0;
	if (argc>2)
	{
		puts("Erreur !\nUsage : soma <chemin_du_fichier>\nUsage : soma");
		exit(-1);
	}
	char *filePath="";
	if (argc==2)
		chargerForme(argv[1]);
	else
	{
		puts("Veuillez entrer le chemin du fichier : ");
		filePath=(char*) malloc(101);
		scanf("%100s",filePath);
		chargerForme(filePath);
	}
	afficherForme();
	depart = GetTickCount();
	puts("\n\n");	
	puts("Calculating...");
	chercherSolution();
	/****************************/
	fin = GetTickCount();
	duree = fin - depart;
    printf("duree: %ld ms soit %ld secondes\n", duree, duree/1000);
	getch();
}